library UnitFacingHistory requires UnitHistory
	//! runtextmacro UnitHistory("Facing")
		private integer Key
		
		method get takes nothing returns real
			return LoadReal(.hash(), Key, whichStep)
		endmethod
		
		private method save takes nothing returns boolean
			call SaveReal(.hash(), Key, currentStep, GetUnitFacing(whichUnit))
			return true
		endmethod
		private method revert takes nothing returns nothing
			call SetUnitFacing(whichUnit, this.get())
		endmethod
		private method clear takes nothing returns nothing
			call FlushChildHashtable(.hash(), Key)
		endmethod
		
		private static method filter takes unit u returns boolean
			return IsUnitType(u, UNIT_TYPE_STRUCTURE) == false
		endmethod
		private method init takes nothing returns nothing
			set Key = .newKey()
		endmethod
	//! runtextmacro endUnitHistory()
endlibrary
